All docs
V22.2
23.1 (CTP)
22.2
22.1
21.2
The page you are viewing does not exist in version 21.2. This link will take you to the root page.
21.1
The page you are viewing does not exist in version 21.1. This link will take you to the root page.
20.2
The page you are viewing does not exist in version 20.2. This link will take you to the root page.
20.1
The page you are viewing does not exist in version 20.1. This link will take you to the root page.
19.2
The page you are viewing does not exist in version 19.2. This link will take you to the root page.
19.1
The page you are viewing does not exist in version 19.1. This link will take you to the root page.
18.2
The page you are viewing does not exist in version 18.2. This link will take you to the root page.
18.1
The page you are viewing does not exist in version 18.1. This link will take you to the root page.
17.2
The page you are viewing does not exist in version 17.2. This link will take you to the root page.

Components Testing

Unit Testing

Unit testing allows you to test single features (units of the code). A unit can be a function or class.

The example below illustrates how to create a unit test for the DataGrid UI component.

Create a HTML file and add your markup to it. The markup also loads the jQuery, QUnit, and DevExtreme libraries from CDN.

HTML
<meta charset="utf-8" />
<title>Test DataGrid</title>
<head>
<script src="https://code.jquery.com/qunit/qunit-2.16.0.js"></script>
<script
    src="https://code.jquery.com/jquery-3.6.0.min.js"
    integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4="
    crossorigin="anonymous"
></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/devextreme/21.1.4/js/dx.all.js"></script>
<link
    rel="stylesheet"
    href="https://code.jquery.com/qunit/qunit-2.16.0.css"
/>
<link
    href="https://cdnjs.cloudflare.com/ajax/libs/devextreme/21.1.4/css/dx.light.css"
    rel="stylesheet"
/>
</head>
<body>
<div id="dataGrid"></div>
<div id="qunit"></div>
<div id="qunit-fixture"></div>
</body>

Add the following script to test the DataGrid configuration and the number of loaded records:

JavaScript
<script>
let createDataGrid = (options, $container) => {
    const dataGridElement = ($container || $("#dataGrid")).dxDataGrid(options);
    QUnit.assert.ok(dataGridElement);
    const dataGrid = dataGridElement.dxDataGrid("instance");
    return dataGrid;
};

QUnit.module("DataGrid", function () {
    QUnit.test("DataGrid is initialized and displays data", function (assert) {
    // act
    const dataGrid = createDataGrid({
        dataSource: {
        pageSize: 3,
        store: [{ id: 1 }, { id: 2 }, { id: 3 }, { id: 4 }],
        },
    });

    // assert
    assert.equal($("#dataGrid").find(".dx-data-row").length, 3);
    });
});
</script>

Open the test file in a browser to see the test report. If the test file contains multiple tests, you can filter the results or re-run specific tests.

Integration Testing

Integration testing helps test a component across multiple units. Integration testing does not test unit by unit, but tests all the units as an entity.

The example below illustrates how to test the DataGrid's functionality. The test code adds a new row, saves it, and checks the results.

To get started with QUnit in your browser, create an HTML file as described in the Unit Testing article and reference the SinonJS script.

HTML
<!-- This script allows you to simulate timers. -->
<script src="https://cdn.jsdelivr.net/npm/sinon@9/pkg/sinon.js"></script>

Add the test code. This code creates the DataGrid and calls the addRow and saveEditData methods to create a new row. Timers allow you to call methods continually since all the processes are asynchronous. The final step is to check whether the DataGrid has two visible rows — an initial row and a newly created row.

JavaScript
<script>
let clock;
let createDataGrid = (options, $container) => {
    const dataGridElement = ($container || $("#dataGrid")).dxDataGrid(options);
    QUnit.assert.ok(dataGridElement, "DataGrid created");
    const dataGrid = dataGridElement.dxDataGrid("instance");
    return dataGrid;
};
QUnit.module("DataGrid", {
    beforeEach: function() {
        clock = sinon.useFakeTimers();
    },
    afterEach: function() {
        clock.restore();
    }
}, () => {
    QUnit.test('Add a row in batch edit mode', function(assert) {
        const array = [{ id: 1, name: 'Test 1' }];

        const dataGrid = createDataGrid({
            editing: {
                mode: 'batch'
            },
            dataSource: {
                key: 'id',
                load: function() {
                    return array;
                },
                insert: function(values) {
                    array.push(values);
                }
            }
        });
        clock.tick(100);

        // Add a row
        dataGrid.addRow();

        clock.tick(100);

        dataGrid.saveEditData();

        clock.tick(200);

        // Check assertion
        assert.strictEqual(dataGrid.getVisibleRows().length, 2, 'visible rows: 2');
        assert.strictEqual(dataGrid.hasEditData(), false, 'DataGrid has no edit data');
    });
});
</script>

Open the test.html file in your browser to see the detailed report of the test and its result.

End-to-End Testing

End-to-End (Functional) testing ignores the component's internal structure and allows you to verify how DevExtreme components work from a user's point of view.

The example below illustrates how to create an End-to-End test for the DataGrid's functionality. The test code emulates a click on the pager.

Create an HTML file and add your markup to it:

HTML
<!DOCTYPE html>
<meta charset="utf-8" />
<title>Test DataGrid</title>
<head>
<script src="https://code.jquery.com/qunit/qunit-2.16.0.js"></script>
<script
    src="https://code.jquery.com/jquery-3.6.0.min.js"
    integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4="
    crossorigin="anonymous"
></script>
<script src="https://cdn.jsdelivr.net/npm/sinon@9/pkg/sinon.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/devextreme/21.1.4/js/dx.all.js"></script>
<link
    rel="stylesheet"
    href="https://code.jquery.com/qunit/qunit-2.16.0.css"
/>
<link
    href="https://cdnjs.cloudflare.com/ajax/libs/devextreme/21.1.4/css/dx.light.css"
    rel="stylesheet"
/>
</head>
<body>
<div id="dataGrid"></div>
<div id="qunit"></div>
<div id="qunit-fixture"></div>
</body>

Add the following script to your test file. This code finds the specified link on the pager and clicks it. A click on the pager triggers the dxclick event. The test checks whether the result page index is the same as the expected page index.

JavaScript
<script>
let clock;
const testElement = $('#dataGrid');

let createDataGrid = (options, $container) => {
    const dataGridElement = ($container || $("#dataGrid")).dxDataGrid(options);
    QUnit.assert.ok(dataGridElement, "DataGrid created");
    const dataGrid = dataGridElement.dxDataGrid("instance");
    return dataGrid;
};

QUnit.module("DataGrid", {
    beforeEach: function() {
        clock = sinon.useFakeTimers();
    },
    afterEach: function() {
        clock.restore();
    }
}, () => {
    QUnit.test('dxPager changes a page index', function(assert) {

        const array = [];
        for (let i = 0; i < 100; i++) {
        array.push({id: i, test: 'test ' + i})
        }

        const dataGrid = createDataGrid({
            dataSource: {
                key: 'id',
                load: function() {
                    return array;
                }
            },
            pager: {
                enabled: true,
                visible: true,
                allowedPageSizes: [5, 10],
                showPageSizeSelector: true
            },
            paging: {
                enabled: true,
                pageSize: 10
            }
        });

        clock.tick(100);

        $(testElement.find('.dx-page')[5]).trigger('dxclick');

        clock.tick(300);

        assert.equal(dataGrid.pageIndex(), 5, 'page index');
    });
});
</script>

DevExtreme React - Components Testing

To test DevExtreme UI components for React, add the React Testing Library library to your project.

This library is automatically added when you create a React project with the Create React App. Alternatively, you can use the following npm command to add the React testing library:

npm install --save-dev @testing-library/react

View on GitHub

Unit Testing

Unit testing allows you to test single features (units of the code). A unit can be a function or class.

The example below illustrates how to create a unit test for the DataGrid UI component.

Create a simple React application and add DevExtereme to it.

npx -p devextreme-cli devextreme add devextreme-react

Add the following imports to the project. Note that this code also loads jQuery, QUnit, and DevExtreme libraries from CDN.

<!--App.js-->
// Import dependencies
import React from 'react'
import {render, screen, waitFor} from '@testing-library/react'
import '@testing-library/jest-dom'
// Import a component
import DataGridComponent from './DataGrid'

Add the following script to test the DataGrid configuration and the number of loaded records:

<!--App.js-->
import React from 'react';
import DataGrid from 'devextreme-react/data-grid';

const dataSource = [{ id: 1, text: 'test' }, { id: 2, text: 'test' }, { id: 3, text: 'test' }, { id: 4, text: 'test' }]

export default function DataGridComponent() {
    return (
        <DataGrid
        dataSource={dataSource}
        />
    );
}    
test('renders DataGrid', async () => {
    render(<DataGridComponent />);

    await waitFor(() => {
        const rowElements = screen.getAllByText('test', {exact: false});
        expect(rowElements.length).toBe(4);
    })
});

In a project, use the npm test command to run the test and see the result.

Integration Testing

Integration testing helps test a component across multiple units. Integration testing does not test unit by unit, but tests all the units as an entity.

The example below illustrates how to test the DataGrid's functionality. The test code adds a new row, saves it, and checks the results.

To get started, create a React application as described in the Unit Testing article and add the test code. This code creates the DataGrid and calls the addRow and saveEditData methods to create a new row. Timers allow you to call methods continually since all the processes are asynchronous. The final step is to check whether the DataGrid has two visible rows — an initial row and a newly created row.

JavaScript
import React from 'react';
import DataGrid, { Editing } from 'devextreme-react/data-grid';

const dataSource = {key: 'id', store: [
    { id: 1, text: 'test' }, 
    { id: 2, text: 'test' }, 
    { id: 3, text: 'test' }, 
    { id: 4, text: 'test' }
]};

export default function DataGridComponent(props) {
    return (
        <DataGrid
        ref={props.setRef}
        dataSource={dataSource}
        >
        <Editing mode={'batch'} />
        </DataGrid>
    );
}

test('renders DataGrid',  async() => {
const dataGridRef = React.createRef();

render(<DataGridComponent setRef={dataGridRef} />);

//DataGrid is rendered asynchronously, so we need to use async/await and waitFor
await waitFor(() => {
    const rowElements = screen.getAllByText('test', {exact: false});
})

dataGridRef.current.instance.addRow();

//give time to render
jest.advanceTimersByTime(200);

dataGridRef.current.instance.saveEditData();

//give time to render
jest.advanceTimersByTime(200);

expect(dataGridRef.current.instance.getVisibleRows().length).toBe(5);
// eslint-disable-next-line testing-library/no-wait-for-multiple-assertions
expect(dataGridRef.current.instance.hasEditData()).toBe(false);
});

Run npm test command in a test project to see the detailed report of the test and its result.

End-to-End Testing

End-to-End (Functional) testing ignores the component's internal structure and allows you to verify how DevExtreme components work from a user's point of view.

The example below illustrates how to create an End-to-End test for the DataGrid's functionality. The test code emulates a click on the pager.

Сreate a React application as described in the Unit Testing article and add the test code. This code finds the specified link on the pager and clicks it. A click on the pager triggers the click event. The test checks whether the result page index is the same as the expected page index.

JavaScript
import React from 'react';
import DataGrid, { Editing } from 'devextreme-react/data-grid';

const dataSource = {key: 'id', store: [
    { id: 1, text: 'test' }, 
    { id: 2, text: 'test' }, 
    { id: 3, text: 'test' }, 
    { id: 4, text: 'test' }
]};

export default function DataGridComponent(props) {
    return (
        <DataGrid
            ref={props.setRef}
            dataSource={dataSource}
        >
        <Editing mode={'batch'} />
        <Paging pageSize={3} />
        </DataGrid>
    );
}

test('Page index is changed from dxPager',  async() => {
    const dataGridRef = React.createRef();
    const { container } = render(<DataGridComponent setRef={dataGridRef} />);

    //DataGrid is rendered asynchronously, so we need to use async/await and waitFor
    await waitFor(() => {
        const rowElements = screen.getAllByText(/test/i);
    })

    // eslint-disable-next-line testing-library/no-container,testing-library/no-node-access
    fireEvent.click(container.querySelectorAll('.dx-page')[1]);

    //give time to render
    jest.advanceTimersByTime(200);

    expect(dataGridRef.current.instance.pageIndex()).toBe(1);
});

All docs
V22.2
23.1 (CTP)
22.2
22.1
21.2
The page you are viewing does not exist in version 21.2. This link will take you to the root page.
21.1
The page you are viewing does not exist in version 21.1. This link will take you to the root page.
20.2
The page you are viewing does not exist in version 20.2. This link will take you to the root page.
20.1
The page you are viewing does not exist in version 20.1. This link will take you to the root page.
19.2
The page you are viewing does not exist in version 19.2. This link will take you to the root page.
19.1
The page you are viewing does not exist in version 19.1. This link will take you to the root page.
18.2
The page you are viewing does not exist in version 18.2. This link will take you to the root page.
18.1
The page you are viewing does not exist in version 18.1. This link will take you to the root page.
17.2
The page you are viewing does not exist in version 17.2. This link will take you to the root page.

Components Testing

Projects created with Angular CLI have built-in testing support with the Jasmine test framework.

Unit Testing

Unit testing allows you to test single features (units of the code). A unit can be a function or class.

The example below illustrates how to create a unit test for the DataGrid UI component.

To get started, create an Angular application and add DevExtreme. Then, add the following imports:

app.component.spec.ts
app.modules.ts
// Import dependencies
import { TestBed } from '@angular/core/testing';
import { DxDataGridModule } from 'devextreme-angular';
// Import the component
import { AppComponent } from './app.component';
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { DxDataGridModule } from 'devextreme-angular';

import { AppComponent } from './app.component';

@NgModule({
declarations: [
    AppComponent
],
imports: [
    BrowserModule,
    DxDataGridModule
],
providers: [],
bootstrap: [AppComponent]
})
export class AppModule { }

Reference DevExtreme style file in the karma.conf.js:

karma.conf.js
files: [
    "node_modules/devextreme/dist/css/dx.light.css"
]

Add the following script to test the DataGrid configuration and the number of loaded records:

app.component.spec.ts
app.component.html
app.component.ts
describe('AppComponent', () => {
beforeEach(async () => {
    jasmine.clock().install();
    await TestBed.configureTestingModule({
    declarations: [
        AppComponent
    ],
    imports: [
        DxDataGridModule
    ]
    }).compileComponents();
});
afterEach( () => {
    jasmine.clock().uninstall();
});

it('renders DataGrid rows',  () => {
    const fixture = TestBed.createComponent(AppComponent);
    fixture.detectChanges();
    const compiled = fixture.nativeElement;
    jasmine.clock().tick(500); // use jasmine clock since DataGrid rendering is async
    expect(compiled.querySelectorAll('.dx-data-row').length).toEqual(4);
});
});
<dx-data-grid
    id="gridContainer"
    [dataSource]="dataSource"
>
</dx-data-grid>
import { Component } from '@angular/core';

@Component({
    selector: 'app-root',
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.css']
})
export class AppComponent {
    title = 'my-app';
    dataSource: any = [{ id: 1, text: 'test' }, { id: 2, text: 'test' }, { id: 3, text: 'test' }, { id: 4, text: 'test' }];
}

Run ng test command to see the test report.

Integration Testing

Integration testing helps test a component across multiple units. Integration testing does not test unit by unit, but tests all the units as an entity.

The example below illustrates how to test the DataGrid's functionality. The test code adds a new row, saves it, and checks the results.

To get started, create an Angular application and import modules as described in the Unit Testing article.

Add the test code. This code creates the DataGrid and calls the addRow and saveEditData methods to create a new row. Timers allow you to call methods continually since all the processes are asynchronous. The final step is to check whether the DataGrid has two visible rows — an initial row and a newly created row.

app.component.spec.ts
app.component.html
app.component.ts
import { TestBed } from '@angular/core/testing';
import { AppComponent } from './app.component';
import {DxDataGridComponent, DxDataGridModule} from 'devextreme-angular';

describe('AppComponent', () => {
beforeEach(async () => {
    jasmine.clock().install();
    await TestBed.configureTestingModule({
    declarations: [
        AppComponent, DxDataGridComponent
    ],
    imports: [
        DxDataGridModule
    ]
    }).compileComponents();
});
afterEach( () => {
    jasmine.clock().uninstall();
});

it('renders five DataGrid rows and is not able to edit data',  () => {
    const fixture = TestBed.createComponent(AppComponent);
    fixture.detectChanges();
    const compiled = fixture.nativeElement;
    jasmine.clock().tick(500);
    const comp = fixture.componentInstance;
    comp.dataGrid.instance.addRow();
    jasmine.clock().tick(500);
    comp.dataGrid.instance.saveEditData();
    jasmine.clock().tick(500);
    expect(comp.dataGrid.instance.getVisibleRows().length).toEqual(5);
    expect(comp.dataGrid.instance.hasEditData()).toBe(false);
});
});
<dx-data-grid
    id="gridContainer"
    [dataSource]="dataSource"
>
    <dxo-editing mode="batch"></dxo-editing>
</dx-data-grid>
import { Component, ViewChild } from '@angular/core';
import { DxDataGridComponent } from 'devextreme-angular';

@Component({
    selector: 'app-root',
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.css']
})
export class AppComponent {
    @ViewChild(DxDataGridComponent, { static: false }) dataGrid: DxDataGridComponent;
    title = 'my-app';
    dataSource = {key: 'id', store: [{ id: 1, text: 'test' }, { id: 2, text: 'test' }, { id: 3, text: 'test' }, { id: 4, text: 'test' }]};
}

Run ng test command to see the test report.

End-to-End Testing

End-to-End (Functional) testing ignores the component's internal structure and allows you to verify how DevExtreme components work from a user's point of view.

The example below illustrates how to create an End-to-End test for the DataGrid's functionality. The test code emulates a click on the pager.

To get started, create an Angular application and import modules as described in the Unit Testing article.

Add the following script to your test file. This code finds the specified link on the pager and clicks it. A click on the pager triggers the dxclick event. The test checks whether the result page index is the same as the expected page index.

app.component.spec.ts
app.component.html
app.component.ts
import { TestBed } from '@angular/core/testing';
import { AppComponent } from './app.component';
import {DxDataGridComponent, DxDataGridModule} from 'devextreme-angular';

describe('AppComponent', () => {
beforeEach(async () => {
    jasmine.clock().install();
    await TestBed.configureTestingModule({
    declarations: [
        AppComponent, DxDataGridComponent
    ],
    imports: [
        DxDataGridModule
    ]
    }).compileComponents();
});
afterEach( () => {
    jasmine.clock().uninstall();
});

it('renders DataGrid and switches its page',  () => {
    const fixture = TestBed.createComponent(AppComponent);
    fixture.detectChanges();
    const compiled = fixture.nativeElement;
    jasmine.clock().tick(500);
    const comp = fixture.componentInstance;
    comp.dataGrid.instance.addRow();
    const event = new MouseEvent('click', {
        bubbles: true,
        cancelable: true,
        view: window
    });
    (compiled.querySelectorAll('.dx-page')[5]).dispatchEvent(event);
    jasmine.clock().tick(500);
    expect(comp.dataGrid.instance.pageIndex()).toBe(5);
});
});
<dx-data-grid
    id="gridContainer"
    [dataSource]="dataSource"
>
    <dxo-pager [visible]="true" [allowedPageSizes]="[5, 10]" [showPageSizeSelector]="true"></dxo-pager>
    <dxo-paging [enabled]="true" [pageSize]="10"></dxo-paging>
</dx-data-grid>
import { Component, ViewChild } from '@angular/core';
import { DxDataGridComponent } from 'devextreme-angular';

@Component({
    selector: 'app-root',
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.css']
})
export class AppComponent {
    @ViewChild(DxDataGridComponent, { static: false }) dataGrid: DxDataGridComponent;
    title = 'my-app';
    array = [];
    dataSource;
    constructor() {
        for (let i = 0; i < 100; i++) {
            this.array.push({id: i, text: 'test ' + i});
        }
        this.dataSource = {key: 'id', store: this.array};
    }
}

Run ng test command to see the test report.